<?php
/**
*
* @package who_is_where  v.0.9.0
* @version $Id: who_is_where.php 2356 2013-02-24 02:21:36Z 4seven $
* @copyright (c) 2013 / 4seven
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx); 

$user->session_begin(false);
$auth->acl($user->data);
$user->setup('viewforum');

// only if rights
if($auth->acl_gets('u_viewprofile', 'a_user', 'a_useradd', 'a_userdel')){

// sending utf8 header / important
header('Content-type: text/html; charset=utf-8');

    // New cookie engine to spare provider load - Part I
	$sessionid     = $config['cookie_name'] . '_base';
	$sessionid_chk = request_var($sessionid, '', false, true);	

	if ($sessionid_chk !== ''){
	$base = true;
	}
	else{
	$base = false;
	echo '<tr class="bg1">
	<td class="name" style="width:25%;">' . $user->lang['WIW_NO_COOKIE'] . '</td>
	<td class="name" style="width:5%; text-align:center;"><img src="images/74t.gif" style="margin-bottom:3px; width:8px;" alt="" /></td>
	<td class="info" style="width:25%; text-align:center;"><img src="images/74t.gif" style="margin-bottom:3px; width:8px;" alt="" /></td>
	<td class="active" style="width:20%;"><img src="images/74t.gif" style="margin-bottom:3px; margin-left:3px; width:8px;" alt="" /></td>
	<td class="active" style="width:25%;"><img src="images/74t.gif" style="margin-bottom:3px; margin-left:3px; width:8px;" alt="" /></td>
	</tr>';
	exit;
	}
	// New cookie engine to spare provider load - Part I	
	
	// Only if cookie
	if($base){


// Configs
	
#
#
#

	//--- CONFIG AREA -- 
	# show guests 
	//set false or true
	  $show_guests = true;

	# show topic name 
	//set false or true
	  $show_topics = true;

	# show forum name 
	# additional to topic name 
	# works only with $show_topics = false;
	//set false or true  
	  $show_forums = false;
	  
	# show post name
	# cant be mixed with $show_forums = true; (check results)
	# you can mix it with $show_topics = true;* 
	#*(results are in "first come, first serve" mode)
	//set false or true 
	  $show_posts  = true;
	  
	# Anonymize some citys .Leave array emtpty, if you dont need it: $ano_citys   = array();
	# Otherwise use it this way: $ano_citys   = array('Paris', 'Hamburg', 'Washington')
	# The town will be overwritten with 'City' (language dependent)
	  $ano_citys   = array('Paris', 'Hamburg', 'Washington');
	  $ano_repla   = $user->lang['CITY'];
	# you can mix it with $show_topics = true;* 	 

	# reminder
	//think about sense and server load on all modes	
	//--- CONFIG AREA -- 


#
#
#

// Functions

	// function user_get_name
	function user_get_name($u_id)
	{	
	   global $db;

	   $sql = 'SELECT username, user_colour
	           FROM ' . USERS_TABLE . '
	           WHERE user_id = ' . $db->sql_escape($u_id);
	   $result = $result = $db->sql_query_limit($sql, 1);
	   $row = $db->sql_fetchrow($result);
	   $db->sql_freeresult($result);

	   if($row)
	   {
	      return ': ' . get_username_string('no_profile', $u_id, $row['username'], $row['user_colour']);
	   }
	   else
	   {
	      return '';
	   }
	}
	// function user_get_name

	// New Topic/Post Engine / 2012

	// function get_att_name
	function get_att_name($a_id)
	{	
	   global $db, $auth, $phpbb_root_path, $phpEx, $user;

	   $sql = 'SELECT real_filename
	         FROM ' . ATTACHMENTS_TABLE . '
	         WHERE attach_id = ' . $db->sql_escape($a_id);
	   $result = $result = $db->sql_query_limit($sql, 1);
	   $row = $db->sql_fetchrow($result);
	   $db->sql_freeresult($result);

	   if($row)	
	   {
		  return $row['real_filename'];
	   }
	}
	// function get_att_name		


	// function get_topic_name
	if($show_topics && !$show_forums)
	{
	function get_topic_name($t_id)
	{	
	   global $db, $auth, $phpbb_root_path, $phpEx, $user;

	   $sql = 'SELECT forum_id, topic_title
	           FROM ' . TOPICS_TABLE . '
	           WHERE topic_id = ' . $db->sql_escape($t_id);
	   $result = $result = $db->sql_query_limit($sql, 1, false, 3600);
	   $row = $db->sql_fetchrow($result);
	   $db->sql_freeresult($result);

	   if($row && $auth->acl_get('f_list', $row['forum_id']))	
	   {
	      $location_url   = append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f=' . $row['forum_id'] . "&amp;t=$t_id");
	      $location       = sprintf($user->lang['READING_IN_TOPIC'], $row['topic_title']);
		  return array($location_url, $location);
	   }
	   else
	   {
	      $location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		  $location = $user->lang['INDEX'];
		  return array($location_url, $location);
	   }
	}
	}
	// function get_topic_name	

	// New Topic/Post Engine / 2012

	// function get_forum_name
	if(!$show_topics && $show_forums && !$show_posts)
	{
	function get_forum_name($t_id, $f_id)
	{	
	   global $db, $auth, $phpbb_root_path, $phpEx, $user;

	   $sql = 'SELECT t.forum_id, t.topic_title, f.forum_name
	           FROM ' . TOPICS_TABLE . ' t, ' . FORUMS_TABLE . ' f
	           WHERE t.topic_id = ' . $db->sql_escape($t_id) . '
			   AND t.forum_id = f.forum_id';
	   $result = $result = $db->sql_query_limit($sql, 1, false, 3600);
	   $row = $db->sql_fetchrow($result);
	   $db->sql_freeresult($result);

	   if($row && $auth->acl_get('f_list', $row['forum_id']))	
	   {
	      $location_url   = append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f=' . $row['forum_id'] . "&amp;t=$t_id");
	      $location       = sprintf($user->lang['READING_IN_TOPIC'], $row['topic_title']);
		  $location_f     = sprintf($user->lang['READING_IN_FORUM'], $row['forum_name']);
		  return array($location_url, $location, $location_f);
	   }
	   else
	   {
	      $location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		  $location = $user->lang['INDEX'];
		  return array($location_url, $location);
	   }
	}
	}
	// function get_topic_name

	// New Topic/Post Engine / 2012	

	// function get_post_name
	if($show_posts && !$show_forums)
	{
	function get_post_name($p_id, $t_f_present = false)
	{	
	   global $db, $auth, $phpbb_root_path, $phpEx, $user, $show_topics, $show_posts;

	   $sql = 'SELECT forum_id, topic_id, post_subject
	         FROM ' . POSTS_TABLE . '
	         WHERE post_id = ' . $db->sql_escape($p_id);
	   $result = $result = $db->sql_query_limit($sql, 1, false, 3600);
	   $row = $db->sql_fetchrow($result);
	   $db->sql_freeresult($result);

	   if($row && $auth->acl_get('f_list', $row['forum_id']))		
	   {
	      $location_url = append_sid("{$phpbb_root_path}viewtopic.$phpEx",  'f=' . $row['forum_id'] . '&amp;t=' . $row['topic_id'] . "&amp;p=$p_id#p$p_id");
	      $location     = ($t_f_present) ? sprintf($user->lang['READING_IN_POSTS'], $row['post_subject']) : sprintf($user->lang['READING_IN_POST'], $row['post_subject']);
		  return array($location_url, $location);
	   }
	   else
	   {
	      $location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		  $location = $user->lang['INDEX'];
		  return array($location_url, $location);
	   }
	}
	}
	// function get_post_name

	// New Topic/Post Engine / 2012

	// function get_agent
	function get_agent($u_ag){

	global $user, $phpbb_root_path;

	// bot switch
	switch ($u_ag) {

    case (strpos($u_ag, 'Firefox') !== false):
        	$b_out = 'firefox.png';
	        $u_out = preg_replace('#(.*?)Firefox/([0-9\.]+)(.*?)#', $user->lang['WIW_FF'] . ' $2' , $u_ag);
        break;
    case (strpos($u_ag, 'MSIE') !== false):
        	$b_out = 'ie.png';	
	        preg_match('#MSIE ([0-9\.]+)#',  $u_ag, $ie_detect);
	        $u_out = $user->lang['WIW_IE'] . ' ' . $ie_detect[1];
        break;
    case (strpos($u_ag, 'Opera') !== false):
        	$b_out = 'opera.png';
	        $u_out = preg_replace('#(.*?)Opera/([0-9\.]+)(.*?)Version/([0-9\.]+)(.*?)#', 
	        $user->lang['WIW_OPERA'] . ' $4', $u_ag);
        break;
	case ((strpos($u_ag, 'Chrome') !== false) && (strpos($u_ag, 'Safari') !== false)):
        	$b_out = 'chrome.png';
        	$u_out = preg_replace('#(.*?)Mozilla/([0-9\.]+)(.*?)Chrome/([0-9\.]+) ([a-zA-Z]+/[0-9\.]+)#', 
        	$user->lang['WIW_CHROME'] . ' $4', $u_ag);
        break;
	case ((strpos($u_ag, 'Chrome') === false) && (strpos($u_ag, 'Safari') !== false)):
        	$b_out = 'safari.png';
        	$u_out = preg_replace('#(.*?)Version/([0-9\.]+) Safari/([0-9\.]+)#', 
        	$user->lang['WIW_SAFARI'] . ' $2', $u_ag);
        break;
	case (strpos(strtolower($u_ag), 'bot') !== false):
            preg_match('#compatible;(.*?);#',  $u_ag, $bot_detect);
            if (!empty($bot_detect)){
            $b_out = 'unknown.png';
            $u_out = $bot_detect[1];}
			else{
            $b_out = 'unknown.png';
            $u_out = $user->lang['WIW_NO_BROWSER'];}			
        break;		
	}

	// all others are unknown / only the major browser / dont blow up this baby
	if (((isset($u_ag) && isset($u_out)) && ($u_ag === $u_out))){
	$b_out = 'unknown.png';
	$u_out = $user->lang['WIW_NO_BROWSER'];}
	else if (!isset($u_ag) || (!isset($u_out))){
	$b_out = 'unknown.png';
	$u_out = $user->lang['WIW_NO_BROWSER'];}

	// return browser output
	return  '<img style="position:relative; top:1px;" src="' . $phpbb_root_path . 'images/browsers/' . $b_out . '" alt="" />' 
	. ' ' . '<span style="position:relative; bottom:5px;">' . $u_out . '</span>';
	
	}
	// function get_agent

	
	# forum info
	// grab and caching
	$sql = 'SELECT forum_id, forum_name, parent_id, forum_type, left_id, right_id
		FROM ' . FORUMS_TABLE . '
		ORDER BY left_id ASC';
	$result = $db->sql_query($sql, 3600);
	
	// tricky thing
	$forum_data = array();
	while ($row = $db->sql_fetchrow($result))
	{
		$forum_data[$row['forum_id']] = $row;
	}
	$db->sql_freeresult($result);

	// dont show hidden users
	$sql_hidden = (!$auth->acl_get('u_viewonline')) ? ' AND session_viewonline != 0 AND user_allow_viewonline !=0' : '';

	// session sql request
	$sql = 'SELECT DISTINCT(s.session_ip), s.session_user_id, s.session_id, s.session_time, s.session_start, s.session_page, s.session_ip, s.session_browser, s.session_viewonline, s.session_forum_id, u.user_id, u.username, u.username_clean, u.user_type, u.user_colour 
	FROM ' . SESSIONS_TABLE . ' s, ' . USERS_TABLE . ' u 
	WHERE s.session_user_id = u.user_id
		AND s.session_time >= ' . (time() - ($config['load_online_time'] * 60)) .
		   $sql_hidden . 
		((!$show_guests) ? ' AND s.session_user_id <> ' . ANONYMOUS : '') .  '
	GROUP BY session_ip, user_id';		

	$result = $db->sql_query($sql);

	// Output page creation time
	/* // Just for debug
	if (defined('DEBUG'))
	{
		$debug_output = $db->sql_num_queries() . ' Queries ';	
	}
	echo ((isset($debug_output)) ? '<div style="padding-left:10px; padding-bottom:10px;">[DEV] Debug: ' . $debug_output . '</div>' : false);
	*/	

    # Array Creation
	while ($row = $db->sql_fetchrow($result))
	{

	// better make an array before, if empty
	$sizeof_row[] = array();

	// splitting relevant vars
	preg_match('#^([a-z0-9/_-]+)#i', $row['session_page'], $on_page);
	if (!sizeof($on_page))
	{
		$on_page[1] = '';
	}

	$on_apps    =   explode("?",$row['session_page']); 
	$on_apps    = (!empty($on_apps[1])) ? $on_apps[1] : '';

	# New Topic/Post Engine / 2012

	
	// take care of mixes

	if($show_topics && !$show_forums)
	{
		preg_match('#(t=)([0-9]+)#', $on_apps, $on_to);
		$t_id = (isset($on_to[2])) ? $on_to[2] : '';
	}

	if(!$show_topics && $show_forums && !$show_posts)
	{
		preg_match('#(t=)([0-9]+)#', $on_apps, $on_to);
		preg_match('#(f=)([0-9]+)#', $on_apps, $on_fo);
		$t_id = (isset($on_to[2])) ? $on_to[2] : '';
		$f_id = (isset($on_fo[2])) ? $on_fo[2] : '';
	}

	if($show_posts && !$show_forums)
	{
		preg_match('#(t=)([0-9]+)#', $on_apps, $on_to);
		preg_match('#(f=)([0-9]+)#', $on_apps, $on_fo);	
		preg_match('#(p=|\#p)([0-9]+)#', $on_apps, $on_po);
		$p_id_true = ((isset($on_to[2]) || isset($on_fo[2])) && isset($on_po[2])) ? true : false;
		$p_id = (isset($on_po[2])) ? $on_po[2] : '';
		$p_id = (isset($on_po2[2])) ? $on_po2[2] : $p_id;
	}
	// New Topic/Post Engine / 2012


	// New Profile Addon
	preg_match('#(&u=)([0-9]+)#', $on_apps, $on_ap);
	$on_apps_u  = (!empty($on_ap[2])) ? user_get_name($on_ap[2]) : '';
	
	$location = $user->lang['INDEX'];
	$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
	

	// new prevent
	$active_post_mode = true;	
	
	
	// switch the on page thing
	switch ($on_page[1])
	{
		/* removed, bcs default is already loaded ^
		case 'index':
			$location = $user->lang['INDEX'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;
		*/

		case 'adm/index':
			$location = $user->lang['ACP'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;

		case 'posting':
		case 'viewforum':
		case 'viewtopic':

			$forum_id = $row['session_forum_id'];


			if ($forum_id && $auth->acl_get('f_list', $forum_id))
			{
				// $location       = '';
				$location_url   = append_sid("{$phpbb_root_path}viewforum.$phpEx", 'f=' . $forum_id);

				if ($forum_data[$forum_id]['forum_type'] == FORUM_LINK)
				{
					$location = sprintf($user->lang['READING_LINK'], $forum_data[$forum_id]['forum_name']);
					break;
				}
				
				switch ($on_page[1])
				{
					case 'posting':
						preg_match('#mode=([a-z]+)#', $row['session_page'], $on_page);
						$posting_mode = (!empty($on_page[1])) ? $on_page[1] : '';
					
						// var_dump($posting_mode);
						
						
						// new prevent
						$active_post_mode = false;
						

						switch ($posting_mode)
						{

							case 'reply':
								// new - topic name and link in reply mode
								if ($show_topics)
								{
								if($t_id   !== ''){$ad_topic  = get_topic_name($t_id);}else{$ad_topic = false;} 
								$ad_top_ar  = explode(":", $ad_topic[1]);
								$ad_top_ar  = (isset($ad_top_ar[1])) ? $ad_top_ar : false;

								if ($ad_top_ar !== false){
								$location   = sprintf($user->lang['REPLYING_MESSAGE'], $forum_data[$forum_id]['forum_name'] . ' ' . $user->lang['IN'] . ' ' . $user->lang['TOPIC'] . ':' . $ad_top_ar[1]);
								$location_url   = $ad_topic[0];}
								}
								else
								{	
								$location   = sprintf($user->lang['REPLYING_MESSAGE'], $forum_data[$forum_id]['forum_name']);
								}
							break;
							
							case 'quote':
								// new - topic name and link in quote mode
								if ($show_topics)
								{
								if($t_id   !== ''){$ad_topic  = get_topic_name($t_id);}else{$ad_topic = false;} 
								$ad_top_ar  = explode(":", $ad_topic[1]);
								$ad_top_ar  = (isset($ad_top_ar[1])) ? $ad_top_ar : false;

								if ($ad_top_ar !== false){
								$location   = sprintf($user->lang['QUOTE_MESSAGE'], $forum_data[$forum_id]['forum_name'] . ' ' . $user->lang['IN'] . ' ' . $user->lang['TOPIC'] . ':' . $ad_top_ar[1]);
								$location_url   = $ad_topic[0];}
								}
								else
								{	
								$location   = sprintf($user->lang['QUOTE_MESSAGE'], $forum_data[$forum_id]['forum_name']);
								}
							break;	

							case 'edit':
								// new - topic name and link in edit mode
								if ($show_topics)
								{
								if($t_id   !== ''){$ad_topic  = get_topic_name($t_id);}else{$ad_topic = false;} 
								$ad_top_ar  = explode(":", $ad_topic[1]);
								$ad_top_ar  = (isset($ad_top_ar[1])) ? $ad_top_ar : false;

								if ($ad_top_ar !== false){
								$location   = sprintf($user->lang['EDIT_MESSAGE'], $forum_data[$forum_id]['forum_name'] . ' ' . $user->lang['IN'] . ' ' . $user->lang['TOPIC'] . ':' . $ad_top_ar[1]);
								$location_url   = $ad_topic[0];}
								}
								else
								{	
								$location   = sprintf($user->lang['EDIT_MESSAGE'], $forum_data[$forum_id]['forum_name']);
								}
							break;
							
							case 'delete':
								// new - topic name and link in edit mode
								if ($show_topics)
								{
								if($t_id   !== ''){$ad_topic  = get_topic_name($t_id);}else{$ad_topic = false;} 
								$ad_top_ar  = explode(":", $ad_topic[1]);
								$ad_top_ar  = (isset($ad_top_ar[1])) ? $ad_top_ar : false;

								if ($ad_top_ar !== false){
								$location   = sprintf($user->lang['DELETE_MESSAGE'], $forum_data[$forum_id]['forum_name'] . ' ' . $user->lang['IN'] . ' ' . $user->lang['TOPIC'] . ':' . $ad_top_ar[1]);
								$location_url   = $ad_topic[0];}
								}
								else
								{	
								$location   = sprintf($user->lang['DELETE_MESSAGE'], $forum_data[$forum_id]['forum_name']);
								}
							break;							
	
							default:
							
								$location = sprintf($user->lang['POSTING_MESSAGE'], $forum_data[$forum_id]['forum_name']);						

							break;
						}
					break;

					case 'viewforum':
						$location = sprintf($user->lang['READING_FORUM'], $forum_data[$forum_id]['forum_name']);
					break;

					case 'viewtopic':
						$location = sprintf($user->lang['READING_TOPIC'], $forum_data[$forum_id]['forum_name']);
					break;
				}
				
			}
			else
			{
				/* removed, bcs default is already loaded ^
				$location = $user->lang['INDEX'];
				$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
				*/
			}
		break;

		case 'search':
		
		$location = $user->lang['SEARCHING_FORUMS'];

			// Grab some common modules
			$url_params = array(

				'search_id=egosearch'	  => 'SEARCH_EGOSEARCH',
				'search_id=unanswered'    => 'SEARCH_UNANSWERED',
				'search_id=unreadposts'	  => 'SEARCH_UNREAD',
				'search_id=newposts'	  => 'SEARCH_NEWPOSTS',
				'search_id=active_topics' => 'SEARCH_ACTIVE',
			
			);

			foreach ($url_params as $param => $lang)
			{
				if (strpos($row['session_page'], $param) !== false)
				{
					$location = $user->lang[$lang];
					break;
				}
			}		

			$location_url = append_sid("{$phpbb_root_path}search.$phpEx");
		break;

		case 'faq':
			$location = $user->lang['VIEWING_FAQ'];
			$location_url = append_sid("{$phpbb_root_path}faq.$phpEx");
		break;

		case 'viewonline':
			$location = $user->lang['VIEWING_ONLINE'];
			$location_url = append_sid("{$phpbb_root_path}viewonline.$phpEx");
		break;

		case 'memberlist':
			$location = $user->lang['VIEWING_MEMBERS'];

			// Grab some common modules
			$url_params = array(
				'mode=viewprofile'	    => 'VIEWING_MEMBER_PROFILE',
				'mode=profile_views'	=> 'VIEWING_PROFILE_VIEWS',	
			);
			
				foreach ($url_params as $param => $lang)
			{
				if (strpos($row['session_page'], $param) !== false)
				{
					$location = $user->lang[$lang];
					break;
				}
			}
			
			$location_url = append_sid("{$phpbb_root_path}memberlist.$phpEx", $on_apps);
		break;

		case 'mcp':
			$location = $user->lang['VIEWING_MCP'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;

		case 'ucp':
		
            // new prevent
            $active_post_mode = false;		

			$location = $user->lang['VIEWING_UCP'];

			// Grab some common modules
			$url_params = array(
			
				// Real user page 1.1.0 / Senky / 2009
				'mode=register'		             => 'VIEWING_REGISTER',
				'i=main&mode=subscribed'         => 'VO_VIEWING_SUBSCRIBED',
				'i=main&mode=bookmarks'	         => 'VO_VIEWING_BOOKMARKS',
				'i=main&mode=drafts'	         => 'VO_VIEWING_DRAFTS',
				'i=attachments&mode=attachments' => 'VO_VIEWING_ATTACHMENTS',
				'i=profile&mode=profile_info'	 => 'VO_EDITING_PROFILE',
				'i=profile&mode=signature'	     => 'VO_EDITING_SIGNATURE',
				'i=profile&mode=avatar'	         => 'VO_EDITING_AVATAR',
				'i=profile&mode=reg_details'	 => 'VO_EDITING_AS',
				'i=prefs&mode=personal'	         => 'VO_EDITING_GS',
				'i=prefs&mode=post'	             => 'VO_EDITING_PD',
				'i=prefs&mode=view'	             => 'VO_EDITING_DO',
				'i=pm&mode=compose'	             => 'POSTING_PRIVATE_MESSAGE',
				'i=pm&mode=drafts'	             => 'VO_MANAGE_PM_DRAFTS',
				'i=pm&folder=inbox'	             => 'VO_PM_INBOX',
				'i=pm&folder=outbox'	         => 'VO_PM_OUTBOX',
				'i=pm&folder=sentbox'	         => 'VO_PM_SENTBOX',
				'i=pm&mode=options'	             => 'VO_PM_OPTIONS',
				'i=groups&mode=membership'	     => 'VO_EDITING_MEMBERSHIP',
				'i=groups&mode=manage'	         => 'VO_EDITING_GROUP',
				'i=zebra&mode=friends'	         => 'VO_EDITING_FRIENDS',
				'i=zebra&mode=foes'	             => 'VO_EDITING_FOES',
				'i=pm&'				             => 'VIEWING_PRIVATE_MESSAGES',
				'i=profile&'		             => 'CHANGING_PROFILE',
				'i=prefs&'			             => 'CHANGING_PREFERENCES',
				// Real user page 1.1.0 / Senky / 2009
			
			);

			foreach ($url_params as $param => $lang)
			{
				if (strpos($row['session_page'], $param) !== false)
				{
					$location = $user->lang[$lang];
					break;
				}
			}

			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;

		case 'download/file':
		
		
		# show filename instead of 'downloading file'
		preg_match('#download\/file.php\?id=([0-9]+)#', $row['session_page'], $down_att);

		$down_att = isset($down_att[1]) ? $down_att[1] : false;
		
		
		    if ($down_att !== false)
		    {
			$location = sprintf($user->lang['DOWNLOAD_FILE'], get_att_name($down_att));
			$location_url = append_sid("{$phpbb_root_path}download/file.$phpEx?id=$down_att&mode=view"); 
		    }
		    else
		    {
			$location = $user->lang['DOWNLOADING_FILE'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
			}	
		break;

		case 'report':
			$location = $user->lang['REPORTING_POST'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;
		
		case 'memberlist_date':
			$location = 'Unfrequently User Manager';
			$location_url = append_sid("{$phpbb_root_path}memberlist_date.$phpEx");
		break;		

		case 'annuaire':
			$location = $user->lang['VIEWING_ANNUAIRE'];

			// Grab some common modules
			$url_params = array(
				'mode=cat&id=1'		=> 'VIEWING_ANNUAIRE_CAT_1',
				'mode=cat&id=2'		=> 'VIEWING_ANNUAIRE_CAT_2',
				'mode=cat&id=3'		=> 'VIEWING_ANNUAIRE_CAT_3',		
			);
			
				foreach ($url_params as $param => $lang)
			{
				if (strpos($row['session_page'], $param) !== false)
				{
					$location = $user->lang[$lang];
					break;
				}
			}
			
			$location_url = append_sid("{$phpbb_root_path}annuaire.$phpEx");
		break;

					case (strpos($on_page[1], 'plupload') !== false):
						$location = $user->lang['POSTING_MESSAGE_JQ'];
						$location_url = false;
					break;		

		default:
		/* removed, bcs default is already loaded ^
		$location = $user->lang['INDEX'];
		$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		*/
		break;
	}
				
		# New Topic/Post Engine / 2012
		// Show Topics				
		if($show_topics && !$show_forums && $active_post_mode) //new prevent
		{
				if($t_id !== '')
				{
						$loc_topic      = get_topic_name($t_id);
						$location       = $loc_topic[1];
						$location_url   = $loc_topic[0];
				}
		}

		// Show Forums with Topics
		if(!$show_topics && $show_forums && !$show_posts && $active_post_mode) //new prevent
		{
					if(($t_id !== '') && ($f_id !== ''))
					{
						$loc_forum      = get_forum_name($t_id,$f_id);
				
						if(isset($loc_forum[2]) && !empty($loc_forum[2]))
						{
						$location       = $loc_forum[1] . $loc_forum[2];
						}
						else
						{
						$location       = $loc_forum[1];
						}
				
						$location_url   = $loc_forum[0];
					}           
		}

		// Show Post Names on Post Links
		if($show_posts && !$show_forums && $active_post_mode) //new prevent
		{
					if(($p_id !== '') && !$p_id_true)
					{
						$loc_post       = get_post_name($p_id, '');
						$location       = str_replace($user->lang['INDEX'], '',$location);
						$location      .= $loc_post[1];
						$location_url   = $loc_post[0];
					}
					else if(($p_id !== '') && $p_id_true)
					{
						$loc_post       = get_post_name($p_id, true);
						$location       = str_replace($user->lang['INDEX'], '',$location);
						$location      .= $loc_post[1];
						$location_url   = $loc_post[0];
					}					
		}
		// New Topic/Post Engine / 2012
		

	// a bit finetuning on username
	$row['username'] = str_replace('Anonymous', $user->lang['GUEST'], $row['username']);
	
	# 1 opening tr
    $echo_1 = '<tr class="bg1">';

	# a hidden user ;)
	$viewon_style = (!$row['session_viewonline']) ? 'font-style:italic;' : '';
	
	# 2 td class echo / username
	$echo_2 = '<td class="name" style="width:15%;' . $viewon_style . '">' . get_username_string('full', $row['session_user_id'], $row['username'], $row['user_colour']) . '</td>';

	// row session ip
	$row_session_ip   = $row['session_ip'];

	// New cookie engine to spare provider load - Part II
    $strings = preg_replace('#([0-9]+)\.([0-9]+)\.(.*)#','$3',$row_session_ip); 
	$cookeys = md5($strings);
	
	$session_id_1     = $config['cookie_name'] . '_' . preg_replace('/[^A-Za-z]/', '', $cookeys) . '_1';
	$session_id_1_chk = request_var($session_id_1, '', false, true);
	
	$session_id_2     = $config['cookie_name'] . '_' . preg_replace('/[^A-Za-z]/', '', $cookeys) . '_2';
	$session_id_2_chk = request_var($session_id_2, '', false, true);

	$session_id_3     = $config['cookie_name'] . '_' . preg_replace('/[^A-Za-z]/', '', $cookeys) . '_3';
	$session_id_3_chk = request_var($session_id_3, '', false, true);

	$session_id_4     = $config['cookie_name'] . '_' . preg_replace('/[^A-Za-z]/', '', $cookeys) . '_4';
	$session_id_4_chk = request_var($session_id_4, '', false, true);	
	
    // prevent
	$citystream = '';
	
	if (($session_id_1_chk !== '') && ($session_id_2_chk !== ''))
	{
		$session_l_ln  = $session_id_4_chk;
		$session_ip_c  = $session_id_1_chk;	
		$session_ip_n  = $session_id_2_chk;
		$session_ip_l  = html_entity_decode(str_replace($ano_citys, $ano_repla, $session_id_3_chk));
		$row_img_tag   = $phpbb_root_path . 'images/flags/' . $session_id_1_chk . '.png';
		$cookie_true   = '';
	}	
	else
	{
	
	    // new curl check for better fallback (and less service)
		$curl_yes = (function_exists('curl_version')) ? true : false;
		
		if($curl_yes)
		{
		$get_content = curl_init();
		curl_setopt($get_content, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($get_content, CURLOPT_URL, "http://www.geoplugin.net/php.gp?ip=$row_session_ip");
		$filestream = curl_exec($get_content); 
		}
		else
		{
		$filestream = @file_get_contents("http://www.geoplugin.net/php.gp?ip=$row_session_ip");
		}


	if($filestream === false)
	{
		$session_l_ln  = '';
		$session_ip_l  = '';
		$session_ip_c  = 'XX';
		$session_ip_n  = '';
		$row_img_tag   = $phpbb_root_path . 'images/flags/XX.png';
		$cookie_true   = '';
	}
	else
	{

		$filestream    = unserialize($filestream);
		
		// new
		$lat_long      = $filestream['geoplugin_latitude'] . '_' . $filestream['geoplugin_longitude'];
		
		$citystream    = $filestream['geoplugin_city'];
		$geostream     = $filestream['geoplugin_countryName'];
		$filestream    = $filestream['geoplugin_countryCode'];

		$session_ip_l  = str_replace($ano_citys, $ano_repla, $citystream);
	    $session_ip_l  = (empty($session_ip_l)) ? $ano_repla : $session_ip_l;		
		$session_ip_n  = $geostream;
		$session_ip_c  = $filestream;
		$session_l_ln  = $lat_long;
	
		$row_img_tag   = $phpbb_root_path . 'images/flags/' . $filestream . '.png';	

		$set_cookie_1  = "$filestream";
		$set_cookie_2  = "$geostream";
		$set_cookie_3  = str_replace($ano_citys, $ano_repla, "$session_ip_l"); // "$citystream";
		$set_cookie_4  = "$lat_long";
		
		$cookie_true   = '<img src="images/74t.gif" style="margin-bottom:3px; margin-left:10px; width:8px;" alt="" />';

		setcookie("$session_id_1", $set_cookie_1, time()+3600*24);
		setcookie("$session_id_2", $set_cookie_2, time()+3600*24);
		setcookie("$session_id_3", $set_cookie_3, time()+3600*24);
		
		if (!in_array($citystream, $ano_citys))
		{
		setcookie("$session_id_4", $set_cookie_4, time()+3600*24);
		}

	}

	}
	// New cookie engine to spare provider load - Part II  	

	
    // new (($session_ip_l !== $user->lang['CITY']) && (!in_array($session_ip_l, $ano_citys)))
	$session_l_ln = (!empty($session_l_ln)) ? str_replace('_',',',$session_l_ln) : false;

    // put to unknown areas another zoom
	if (($session_l_ln && !in_array($citystream, $ano_citys)) && ($session_ip_l == $ano_repla))
	{
	$m_zoom =  '&z=6&t=m';
	}
	else
	{
	$m_zoom =  '&z=12&t=m';
	}

	// google maps link only if not ano
	$l_ln_true_1  = ($session_l_ln && !in_array($citystream, $ano_citys)) ? '<a href="http://maps.google.com/?q=' . $session_l_ln . $m_zoom . '" style="outline:none;" onclick="window.open(this.href);return false;">' : '';
	$l_ln_true_2  = ($session_l_ln && !in_array($citystream, $ano_citys)) ? '</a>' : '';

	# 3 td class echo / flags with ip output for admins and mods
	$echo_3 = '<td class="name" style="width:5%; text-align:center;">' . $l_ln_true_1 . '<img src="' . $row_img_tag . '" alt="" ' . (($auth->acl_get('a_') || $auth->acl_get('m_')) ? 'title="' . $session_ip_n . ' - ' . $session_ip_l . ' - ' . $row_session_ip . '"' : 'title="' . $session_ip_n . ' - ' . $session_ip_l . '"') . ' />' . $l_ln_true_1 . '</td>';

	# 4 td class echo / location
	$echo_4 = '<td class="info" style="width:40%;"><a href="' . $location_url.'" title="'.$location.'">'.$location . '</a>' . $on_apps_u . '</td>';

	# 5 td class echo / session start
	$echo_5 = '<td class="active" style="width:15%; ">' . $user->format_date($row['session_start']) . $cookie_true . '</td>';	

	// get useragent by session_browser
	$row['session_browser'] = get_agent($row['session_browser']);

	# 6 td class echo / show useragent
	$echo_6 = '<td class="active" style="width:25%;">' . (((strlen($row['session_browser'])) > 180) ? (mb_substr($row['session_browser'], 0, 180) . '...') : $row['session_browser']) . '</td>';

	# 7 closing tr
	$echo_7 = '</tr>';	

    // prepare echo out of the whole construct	
	$echo_out[] = $echo_1 . $echo_2 . $echo_3 . $echo_4 . $echo_5 . $echo_6 . $echo_7;

	}

	// free sql result
	$db->sql_freeresult($result);

// echo out the whole construct, if set
if (isset($echo_out))
{
foreach($echo_out as $out)
       {
       echo $out;
       }
}

// else no online users
else{
	echo '<tr class="bg1">
	<td class="name" style="width:10%;">' . $user->lang['NO_ONLINE_USERS'] . '</td>
	<td class="name" style="width:5%; text-align:center;"><img src="images/74t.gif" style="margin-bottom:3px; width:8px;" alt="" /></td>
	<td class="info" style="width:45%; text-align:center;"><img src="images/74t.gif" style="margin-bottom:3px; width:8px;" alt="" /></td>
	<td class="active" style="width:15%;"><img src="images/74t.gif" style="margin-bottom:3px; margin-left:3px; width:8px;" alt="" /></td>
	<td class="active" style="width:25%;"><img src="images/74t.gif" style="margin-bottom:3px; margin-left:3px; width:8px;" alt="" /></td>
	</tr>';
}

}

}
// else no online users
else{
	echo '<tr class="bg1">
	<td class="name" style="width:10%;">' . $user->lang['NO_ACCESS'] . '</td>
	<td class="name" style="width:5%; text-align:center;"><img src="images/74t.gif" style="margin-bottom:3px; width:8px;" alt="" /></td>
	<td class="info" style="width:45%; text-align:center;"><img src="images/74t.gif" style="margin-bottom:3px; width:8px;" alt="" /></td>
	<td class="active" style="width:15%;"><img src="images/74t.gif" style="margin-bottom:3px; margin-left:3px; width:8px;" alt="" /></td>
	<td class="active" style="width:25%;"><img src="images/74t.gif" style="margin-bottom:3px; margin-left:3px; width:8px;" alt="" /></td>
	</tr>';
}
?>